//
// FTS client library
// Copyright (C) 2001 by IRCAM-Centre Georges Pompidou, Paris, France.
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation; either version 2.1
// of the License, or (at your option) any later version.
// 
// See file COPYING.LIB for further informations on licensing terms.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//

using System;
using System.IO;
using System.Diagnostics;

namespace ircam.fts.client
{
    public class FtsProcess : Process
    {
        public FtsProcess(string cmd, string[] args)
        {
            string ftsArgs = null;

            foreach (string str in args)
                ftsArgs += str + " ";

            process = new Process();
            ProcessStartInfo psi = new ProcessStartInfo(cmd, ftsArgs.Trim());
            psi.CreateNoWindow = true;
            psi.UseShellExecute = false;
            psi.RedirectStandardInput = true;
            psi.RedirectStandardOutput = true;
            psi.RedirectStandardError = true;
            process.StartInfo = psi;
            process.Start();
        }

        public FtsProcess(string cmd)
        {
            process = new Process();
            ProcessStartInfo psi = new ProcessStartInfo(cmd);
            psi.CreateNoWindow = true;
            psi.UseShellExecute = false;
            psi.RedirectStandardInput = true;
            psi.RedirectStandardOutput = true;
            psi.RedirectStandardError = true;
            process.StartInfo = psi;
            process.Start();
        }

        private Process process;
    }
}