//
// jMax
// Copyright (C) 1994, 1995, 1998, 1999 by IRCAM-Centre Georges Pompidou, Paris, France.
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// See file LICENSE for further informations on licensing terms.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 

using System;

namespace ircam.jmax.toolkit
{
    /// <summary> The interface for the classes that can own a selection (ex,
    /// editor's window 
    /// </summary>
    public interface ISelectionOwner
    {
        // implementation notes: This class is used in the Explode package and
        // is currently not used by the toolkit's selection support 
        // (SelectionHandler, SelectionListener, AbstractSelection classes). 
        // The toolkit does not support selection ownership at all (but it should!)
        /// <summary> The selection owned by this object has been disactivated </summary>
        void SelectionDisactivated();
        /// <summary> The selection owned by this object has been activated </summary>
        void SelectionActivated();
    }
}