//
// jMax
// Copyright (C) 1994, 1995, 1998, 1999 by IRCAM-Centre Georges Pompidou, Paris, France.
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// See file LICENSE for further informations on licensing terms.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 

using System;
using System.Drawing;

namespace ircam.jmax.toolkit
{
    /// <summary> The objects that use the StatusBar must implement this
    /// interface 
    /// </summary>
    public interface IStatusBarClient
    {
        /// <summary> The name that will be shown in the status bar. </summary>
        string Name
        {
            get;
        }

        /// <summary> The icon that will be shown in the status bar.
        /// Return null if this client has no icons. 
        /// </summary>
        string Icon
        {
            get;
        }
    }
}